# JacoPad

Jacopad is a tablet on which you can place tokens (forward, left, right, function) to control the jacobot wirelessly.

## Box

### Shematic

`/jacopad/arduino/shematics/shematics.png`  
![picture](https://git.afpy.org/Adrien/JacoBot/raw/branch/jacopad/jacopad/arduino/shematics/shematic.png)

### Design

All parts of the JacoPad's box tokens are in `/jacopad/parts/box/`

## Tokens

There are 16 token slots, 6 of which are for the content of the function, which can be called up using the function token.

### How it works

All the tokens have a resistor that will be measured by the arduino, which will be able to deduce the type of token.

### Resistors value

**minimum value < _optimum value_ < maximum value**

- **Forward :** 400 < _700_ < 1000
- **Left :** 1000 < _2500_ < 4000
- **Right :** 4000 < _6000_ < 7500
- **Function :** 7500 < _8500_ < 10000

### Design

All parts of the JacoPad's tokens tokens are in `/jacopad/parts/tokens/`

## Wireless protocol

The Jacopad and the Jacobot talk via [NRF24L01](https://pecquery.wixsite.com/arduino-passion/le-transmetteur-radio-nrf24l01) following this protocol:

- **Use canal 120**
- **24-character message**  
  Exemple :

```
"JACOFFRLfLfNNNFFLRLN07"
 \__/\________/\____/\/
  1      2       3   4

- 1: The first part will always be "JACO",
  to differentiate it from other projects using the same canal.

- 2: The second part is the 10 tokens placed on the normal slots.
  "F" : Forward
  "L" : Left
  "R" : Right
  "f" : Function
  "N" : Nothing

- 3: The third part is the same that the second but for the
  function slots and with only 6 tokens.

- 4: The fourth part is the checksum of the 3 others.
```
