#include <RF24.h>
#include <SPI.h>
#include <Arduino.h>

#include "Radio.h"

#define tunnel "PIPE1"

Radio::Radio(int canal, int pinCE, int pinCSN) {
    m_canal = canal;
    m_pinCE = pinCE;
    m_pinCSN = pinCSN; 
    radio = new RF24(m_pinCE, m_pinCSN);
    const byte adress[6] = tunnel;

    if (!radio->begin()) {
        Serial.println("Error while initialise the NRF module");
        while (1); 
    }
    Serial.println("Radio module initialised");
    radio->openWritingPipe(adress); // Ouverture du tunnel en ÉCRITURE
    radio->setChannel(canal); // On configure le canal
    radio->setPALevel(RF24_PA_MIN); // Sélection du niveau du signal
    radio->stopListening(); // En mode Emetteur. Mode réception : radio.startListening();
}

boolean Radio::send(char message[32]) {
    radio->write(&message, sizeof(message));

}