#pragma once

// Token class declaration
class Token {
private:
    int m_pin;            // This pin will measure the resistance
    float m_base;         // Base value used for scaling the sensor reading
    float m_limits[3];    // Array of limit values for token type determination
    float m_min;          // Minimum value threshold for token range
    float m_max;          // Maximum value threshold for token range

public:
    // Constructor declaration
//   * @param limits array meaning, for those values : {1000.0, 4000.0, 7500.0}
//                   < 1000 Ω                 <  4000 Ω               <  7500 Ω
//         Token 1                 Token 2                  Token 3             Token 4
    Token(int pin, float base, float limits[3], float min, float max);

    // Method to read sensor value and return adjusted value
    float read();

    // Method to determine and return the type of token based on the sensor value
    int type();
};
