#include <Arduino.h>

#include "token.h"
#include "Radio.h"

#define SEND_PIN 2
#define STOP_PIN 3

// Define array of limits for token j1
float limits1[3] = {1000.0, 4000.0, 7500.0};

// Create an instance of Token class named j1 with specified parameters
Token j1(0, 10000, limits1, 400, 10000);
Token j2(1, 10000, limits1, 400, 10000);
Token j3(2, 10000, limits1, 400, 10000);
Token j4(3, 10000, limits1, 400, 10000);
Token j5(4, 10000, limits1, 400, 10000);
Token j6(5, 10000, limits1, 400, 10000);
Token j7(6, 10000, limits1, 400, 10000);
Token j8(7, 10000, limits1, 400, 10000);
Token j9(8, 10000, limits1, 400, 10000);
Token j10(9, 10000, limits1, 400, 10000);
Token j11(10, 10000, limits1, 400, 10000);
Token j12(11, 10000, limits1, 400, 10000);
Token j13(12, 10000, limits1, 400, 10000);
Token j14(13, 10000, limits1, 400, 10000);
Token j15(14, 10000, limits1, 400, 10000);
Token j16(15, 10000, limits1, 400, 10000);

Token tokens[16] = {j1, j2, j3, j4, j5, j6, j7, j8, j9, j10, j11, j12, j13, j14, j15, j16};

Radio *radio;

void setup() {
    Serial.begin(9600); // Initialize serial communication at 9600 baud rate
    radio = new Radio(120, 7, 8);
    pinMode(SEND_PIN, INPUT);
    pinMode(STOP_PIN, INPUT);
}

void loop() {
    if(digitalRead(SEND_PIN)) {
        char message[24] = "JACO";
        for(int i=0; i<16; i++) {
            int result = tokens[i].type();
            if(result==0) {
                message[4+i] = (char)"N";
            } else if(result==1) {
                message[4+i] = (char)"F";
            } else if(result==2) {
                message[4+i] = (char)"L";
            } else if(result==3) {
                message[4+i] = (char)"R";
            } else {
                message[4+i] = (char)"f";
            }
        }
        char checksum[] = "AA";
        for(int i=0; i<11; i++) {
            checksum[0] ^= message[i*2];
            checksum[1] ^= message[i*2+1];
        }
        message[22] = checksum[0];
        message[23] = checksum[1];
    } else if (digitalRead(STOP_PIN)){
        radio->send("JACOSTOP");
    }
}